<!DOCTYPE html>
<html lang="no" prefix="og: http://ogp.me/ns#">
 
  <head>
    <meta charset="utf-8">
    <title>Teknologi - {{lodspk.title}}</title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <link rel="shortcut icon" type="image/x-icon" href="{{lodspk.home}}/img/favicon.ico">
	
	<script src="//code.jquery.com/jquery.js"></script>
	<!-- <script type="text/javascript" src="{{lodspk.home}}js/jquery.js"></script> -->
	
	<!-- Latest compiled and minified CSS -->
	<link rel="stylesheet" href="//netdna.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css">
	
	<!-- Latest compiled and minified JavaScript -->
	<script src="//netdna.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>

	<link href="{{lodspk.home}}css/basic.css" rel="stylesheet" type="text/css" media="screen" />
    
    <!-- Font Awesome -->
    <!-- <link rel="stylesheet" href="{{lodspk.home}}static/Font-Awesome/css/font-awesome.min.css"> -->
    <link href="//netdna.bootstrapcdn.com/font-awesome/4.6.1/css/font-awesome.min.css" rel="stylesheet">
    
    <!-- Leaflet CSS -->
    <link rel="stylesheet" href="http://cdn.leafletjs.com/leaflet-0.6.4/leaflet.css" />
	<!--[if lte IE 8]>
	    <link rel="stylesheet" href="http://cdn.leafletjs.com/leaflet-0.6.4/leaflet.ie.css" />
	<![endif]-->
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="">
	
	<link href='http://fonts.googleapis.com/css?family=IM+Fell+Great+Primer' rel='stylesheet' type='text/css'>

    <link rel="alternate" type="application/rdf+xml" title="RDF/XML Version" href="{{lodspk.local.value}}.rdf" />
    <link rel="alternate" type="text/turtle" title="Turtle Version" href="{{lodspk.local.value}}.ttl" />
    <link rel="alternate" type="text/plain" title="N-Triples Version" href="{{lodspk.local.value}}.nt" />
    <link rel="alternate" type="application/json" title="RDFJSON Version" href="{{lodspk.local.value}}.json" />
    
    <script type="text/javascript" src="{{lodspk.home}}js/bootstrap-typeahead.js"></script>
    <script type="text/javascript">
    $(document).ready(function(){
        $('.typeahead').typeahead({
            minLength: 4,
            source: function (typeahead, query) {
              $('.typeahead').addClass('wait');[]
              return $.get('{{lodspk.home}}search/'+encodeURIComponent(query), { }, function (data) {
                  $('.typeahead').removeClass('wait');[]
                  return typeahead.process(data);
              }, 'json');
            },
            onselect: function (obj) {
              $('.typeahead').attr('disabled', true);
              window.location = obj.uri;
            }
        });
        $(".header-search").on('keyup', function(){$("form").attr("action", '{{lodspk.home}}search/'+$(this).val())});
    });
    </script>
    

  </head>
  <body>
      <div id="wrap">
	    <header>
			<nav style="margin-bottom: 0;" class="navbar navbar-inverse navbar-static-top marcus-header" role="navigation">  
				<div class="container-fluid">
					<div class="navbar-header">
			            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
			              <i class="fa fa-bars fa-2x" aria-hidden="true"></i>
			            </button>
			            <img class="logo" style="float: left;" data-pin-nopin="true" src="{{lodspk.home}}img/UiBmerke_white.svg">
			            <a class="navbar-brand" href="{{lodspk.home}}">{{lodspk.title}}</a>
			            <a class="nav-subtitle hidden-xs hidden-sm hidden-md" href="{{lodspk.home}}"><small>Spesialsamlingene ved <br>Universitetsbiblioteket i Bergen</small></a>
		        	</div>
		        	
        <div class="collapse navbar-collapse">
          <form class="navbar-form pull-right" role="search" method="get" action="/search">
						<div class="input-group">
							<input type="text" class="form-control" placeholder="Søk ..." name="q">
							<span class="input-group-btn">
				
								<button type="submit" class="btn btn-default">
									<i class="fa fa-search fa-lg">
										<span class="sr-only">Search</span>
									</i>
								</button>
							</span>
						</div>
					</form>
					
	       
	     <ul class="nav navbar-nav navbar-right">
						 <li><a href="{{lodspk.home}}">Hjem</a></li>

		              	<li class="dropdown">
						  	<a id="browse1" class="dropdown-toggle" role="button" data-toggle="dropdown" data-target="#" href="#"> Meny <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
						  	<ul class="dropdown-menu" aria-labelledby="browse1" role="meny">
							

								
				<li><a href="{{lodspk.home}}collections"><i style="color: #aaa;" class="fa fa-th fa-fw"></i>  Samlinger</a></li>
				<li><a href="{{lodspk.home}}search/?filter=type.exact%23Fotografi&filter=type.exact%23Album&filter=type.exact%23Grafikk&filter=type.exact%23Postkort"><i style="color: #aaa;" class="fa fa-picture-o fa-fw"></i>  Bilder</a></li>
				<li><a href="{{lodspk.home}}events"><i style="color: #aaa;" class="fa fa-calendar fa-fw"></i>  Hendelser</a></li>
				<li><a href="{{lodspk.home}}albums"><i style="color: #aaa;" class="fa fa-book fa-fw"></i>  Album</a></li>
				<li><a href="{{lodspk.home}}exhibitions"><i style="color: #aaa;" class="fa fa-university fa-fw"></i>  Utstillinger</a></li></ul>
						</li>
						<li class="dropdown">
							<a id="browse1" class="dropdown-toggle" role="button" data-toggle="dropdown" data-target="#" href="#"> Om <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
							<ul class="dropdown-menu" aria-labelledby="browse2" role="meny">
								<li><a href="{{lodspk.home}}about-marcus"><i class="fa fa-archive"></i> Om Marcus</a></li>
								<li><a href="http://sparql.ub.uib.no"><i class="fa fa-cubes"></i> Åpne data (Sparql)</a></li>
								<li><a href="{{lodspk.home}}technology.html"><i style="color: black;" class="fa fa-cog"></i> Teknologi</a></li>
								<li><a href="{{lodspk.home}}stats"><i style="color: black;" class="fa fa-bar-chart-o"></i> Statistikk</a></li>
							</ul>
						</li>						
            	<li>
            		<a href="/cart.html"><span class="fa fa-lg fa-shopping-cart"></span> <span class="hidden">Handlekurv</span> <span style="margin-top: -8px;" class="label label-primary simpleCart_quantity"></span></a>
				</li>
     
					</ul>
				</div>
				
	
			</div>
	    </nav><!--/.nav-collapse -->
      </header>  
    
    <div class="container">
    	<div class="row">
			<div class="col-lg-8">
            	<h1>Teknologi</h1>
            	<p class="lead"><strong>Marcus</strong> er et resultat av mange år med digitalisering og registrering ved Spesialsamlingene ved Universitetsbiblioteket i Bergen og prosjektene <i><a href="http://www.uib.no/tilvekstavd/om-biblioteket/prosjekter/digitale-fulltekstarkiv">Digitale fulltekstarkiv</a></i> og <i><a href="http://www.ntnu.no/ub/tilbyr/utgivelser/prosjekter">Linked Data - et nettverk</a></i> i 2012-2013. For å få mest ut av alt som er registrert av metadata i ulike system og format har vi besluttet å konvertere alt til <a href="http://sv.wikipedia.org/wiki/L%C3%A4nkad_data">Linked data</a>. Dette har vi valgt for å knytte sammen alle våre egne samlinger/datasett, men også for å dele vår data og bruke hva som allerede eksisterer av Linked Data. Vi er langt fra en ferdig teknisk infrastruktur, men vi har kommet godt i gang.</p>
            	
            	<div class="embed-responsive embed-responsive-4by3">
            	<iframe src="//player.vimeo.com/video/36752317" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>
            	</div>
            	<p><a href="http://vimeo.com/36752317">Linked Open Data - What is it?</a> fra <a href="http://vimeo.com/europeana">Europeana</a> på <a href="https://vimeo.com">Vimeo</a>.</p>
            	
            	<h2>Bakgrunn</h2>
            	<p>Bakgrunnen for å gjøre dette er gamle systemer som er nær sagt umulige å vedlikeholde, og av og til et fravær av egnede systemer for å registrere og formidle våre samlinger.</p>
            	
            	<h2>Infrastruktur</h2>
            	<img class="img-responsive col-lg-12" src="https://docs.google.com/drawings/d/11Esm4wOT98oWmo6Ice3tbj9QXGbSFdh5By24ZX9XqQ8/pub?w=1080&amp;h=366">
            	
            	<h2>Verktøy</h2>
            	<p>En stor grunn til at vi har kunnet gjennomføre dette prosjektet er Open Source programvare. Alle funksjonene vi trenger finner vi gratis programvare for, uten å binde oss til kommersielle og proprietære leverandører. Dersom vi ikke kan lese dokumentasjon eller se på koden og installere programvaren på under én dag, skal det mye til for at vi benytter oss av det i denne fasen av prosjektet.</p>
            	
            	<h3>Konvertering av data</h3>
            	<p>Prosjektene har handlet mye om å konvertere data fra ulike format til rdf. Våre data har hovedsakelig vært i CSV-filer dumpet fra databaser og EAD-XML filer.
        	    <h4>OpenRefine</h4>
        	    <p>CSV-filene har hovedsakelig blitt konvertert ved OpenRefine (tidligere Google Refine). Dette verktøyet er laget for å vaske store mengder data og passer derfor godt til å rydde opp i databaser der små og store feil har sneket seg inn gjennom årenes løp. Ved hjelp av utvidelser har vi mappet eller "reconciled" våre data med eksterne datasett som Freebase. Deretter er alle kolonner blir mappet til vår datamodell og dataene eksporter som RDF.
				<ul>
        	    	<li><a href="http://openrefine.org/">OpenRefine</a></li>
					<li><a href="http://code.zemanta.com/sparkica/">LODRefine</a></li>
				</ul>
        	    
        	    <h4>XSLT</h4>
        	    <p>Et av våre verktøy i dataproduksjonen for Marcus er utviklingen av <a href="http://www.w3.org/standards/techs/xslt">XSLT</a> stilark for å transformere XML til RDF. Denne produksjonen består ofte av flere steg.</p>

				<p>For prosjekter hvor vi har velformet XML og godt beskrevne metadata, bruker vi individuelle mappinger basert på skjema, transkripsjon og gjeldende praksis i de individuelle prosjektene. To eksempler på dette er Diplom- og Fragmentsamlingen.</p>

				<p>Vi har mappet skjemaer som <a href="http://www.loc.gov/ead/">EAD</a> og <a href="http://www.tei-c.org/index.xml">TEI</a> (<a href="">P4</a> og <a href="http://www.tei-c.org/Guidelines/P5/">P5</a>) til vår ontologi. Selv om vi gjenbruker mye av funksjonaliteten som er knyttet til disse, mapper vi RDF på et prosjekt til prosjekt basis, og ikke skjema til ontologi. Dette gjør vi fordi det er ulik praksis og størrelse på beskrevne dokumenter i de forskjellige prosjektene.</p>

				<p>Spesialsamlingen ved Universitet i Bergen har parallelt med alle prosjektene digitalisert dokumenter og kilder, og lagret disse i vel-strukturerte kataloger. Vi bruker denne strukturen til å produsere formidlingsklare digitale objekter. For å jobbe med filer på system har vi også brukt XSLT og den siste kandidat til w3c specification <a href="http://expath.org/">Expath</a> (spesifikasjon for filbehandling), implementert av <a href="http://www.saxonica.com">Saxonica</a> i sin parser. Denne gir XSLT muligheten til å programmere rundt eget filsystem.</p>
				<p>Ved hjelp av dette har vi en arbeidsflyt for filhåndtering og RDF genering:</p>

				<ol>
					<li>Stilark som analyserer alle undermapper fra mappen den blir kjørt i, og som rensker opp mappen basert på helt enkle regler. Den legger til /Pdf /Jpeg /Tiff og /Dzi mapper der det finnes slike filer, og rapporterer tilbake feil i mappestruktur.</li>
					<li>Stilark som produserer shell filer for å generere web-klare objekter. Vi bruker <a href="http://www.vips.ecs.soton.ac.uk">VIPS</a> for å produsere ut forskjellige thumbnails, dzi-filer og store jpeg filer fra Tiff kildefilen.</li>
					<li>Kjøring av shell skript som ble generert.</li>
					<li>Stilark som analyserer mappestruktur og returnerer en XML med sti til alle filer samt attributter og identifiere.</li>
					<li>Nok et stilark som mapper dette til RDF. Her slås identifiers opp i ett parameterisert dokument for å finne type og identifer. To lister med feil generes.</li>
						<ul>
							<li>Metadata RDF-filen som beskrives i 5. er ofte produsert fra Google Speadsheet. Vi bruker <a href="http://easyopendata.com">EasyOpenData</a>, som strømmer XML-filer til oss fra disse regnearkene. Dette gir oss muligheten til å vedlikeholde en liste over strømmede filer, som vi kan transformere med et enkelt stilark som tar for seg metadataproduksjonen til de digitale kuratorene.</li>
						</ul>
					<li>Objekter i metadatafilen som ikke finnes i mappestrukturen (signaturen kjennes ikke igjen) og beskrevne identifikatorer fra mapper som ikke er beskrev i metadatafilen.</li>
				</ol>

				<p><small>I tillegg jobber vi også med å vedlikeholde Wittgenstein arkivets TEI-filer til DM2E Europeana datamodel sammen med Kilian Schmidtner fra Humboldt Universitetet i Berlin. For Wittgensteinarkivet vedlikeholder og produserer vi <a href="">stilark for å lage Wittgensteinarkivets egen vitenskaplige ontologi</a>. Hvis du vil vite mer om bruken av ontologier i filosofi og for Ludvig Wittgenstein spesielt, sjekk ut denne artikkelen: <a href="">placeholder</a></small></p>
        	    
        	    <h3>Registreringsklient</h3>
        	    <p>Vi ønsker å ha en registreringsklient som å kunne produsere og redigere våre Linked Data. Denne funksjonen er kanskje der det er minst utvalg av løsninger.
        		<p>Vi har eksperimentert med Protégé som vår registreringsklient. Med et server-klient oppsett kan alle jobbe mot samme datasett på serveren med lokalt installerte klienter. Dette oppsettet har noen problemer med hastigheten og føles lite responsivt, men vi håper å få ordnet dette.
        		<ul>
        			<li><a href="http://protege.stanford.edu/">Protégé</a></li>
        		</ul>
        		<p>Google Spreadsheet bruker vi til å registrere enkelt dokument i ulike samlinger og sammenhenger. Disse regnearkene konverteres til Linked Data med OpenRefine eller med XSLT-stilark.
        		
<!--
        		<h3>Lagring av data og filer</h3>
        		<h4>Fuseki</h4>
        		<ul>
        			<li><a href="http://jena.apache.org/documentation/serving_data/index.html">Fuseki</a></li>
        		</ul>
        		
        		<h4>Filer</h4>
-->
        		
        		<h3>Visualisering</h3>
        		<p>Vi har testet ulike system for å lage nettsider på vår Linked Data. <a href="https://drupal.org/">Drupal</a> var tidlig en kandidat, men det føltes tungvint og lite fleksibelt. <a href="https://github.com/csarven/linked-data-pages">Linked Data Pages</a> var en tidlig utfordrer sammen med <a href="http://graphite.ecs.soton.ac.uk/">Graphite</a>. Etter litt testing gikk vi videre med LODSpeakr. LODSpeakr har vist seg å være et enkelt system å lage tilpassede visninger på våre materialtyper.</p>
        		<ul>
        			<li><a href="http://lodspeakr.org/">LODspeakr</a></li>
        		</ul>
            	
            	<!--
<h2>Ontologi</h2>
            	<p><a href="http://marcus.uib.no/files/ontology/ubbont.owl">ubbont</a></p>
            	<ul>
            		<li><strong>55</strong>: klasser</li>
            		<li><strong>86</strong>: datatype-egenskaper</li>
            		<li><strong>71</strong>: objekt-egenskaper</li>
            	</ul>
-->
            	
            	<h2>Takk til</h2>
            	<p>En stor takk til NTNU, Bergen offentlige bibliotek, Robert Engels og alle som har hjulpet oss med prosjektene! Prosjektene er støttet av Nasjonalbiblioteket.</p>
            </div>
			
			<div class="col-lg-4">
  			<h3>Åpent Sparql endpoint</h3>
  			<p><a class="btn btn-primary btn-lg" href="http://sparql.ub.uib.no">Åpne data</a></p>
  			<p>Vi har åpnet data som Marcus er laget på og du kan utforske de i vårt åpne Sparql endpoint. Det finne mange <a href="http://www.cambridgesemantics.com/semantic-university/sparql-by-example">gode sider</a> som hjelper det med å komme i gang med å spørre våre data og få data i den form du foretrekker. Alle data er <a href="https://creativecommons.org/publicdomain/zero/1.0/">CCO</a>!</p>
  			
  			<hr>
  			
				<a class="twitter-timeline" data-dnt="true" href="https://twitter.com/UiB_UBDST" data-widget-id="540213401990234114">Tweets by @UiB_UBDST</a>
<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+"://platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>
				
				<h3>Kontaktinformasjon</h3>
				<p>Ta kontakt med oss om du har kommentarer, finner feil, eller ønsker å snakke med oss som jobber med nettsidene:</p>
				<ul>
					<li><a href="mailto:tarje.lavik@ub.uib.no">Tarje Sælen Lavik</a></li>
					<li>Øyvind Gjesdal</li>
				</ul>
				
			</div>
		</div>
	</div>
	</div>
    </div>
    {%include "../includes/footer.inc"%}
  </body>
</html>
